Index: branches/SHM-dev/source/Lib/TLibDecoder/TDecGop.cpp
===================================================================
--- branches/SHM-dev/source/Lib/TLibDecoder/TDecGop.cpp	(revision 855)
+++ branches/SHM-dev/source/Lib/TLibDecoder/TDecGop.cpp	(revision 856)
@@ -54,4 +54,8 @@
 //! \{
 static void calcAndPrintHashStatus(TComPicYuv& pic, const SEIDecodedPictureHash* pictureHashSEI);
+#if Q0074_COLOUR_REMAPPING_SEI
+static Void applyColourRemapping(TComPicYuv& pic, const SEIColourRemappingInfo* colourRemappingInfoSEI, UInt layerId=0 );
+static std::vector<SEIColourRemappingInfo> storeCriSEI; //Persistent Colour Remapping Information SEI
+#endif
 // ====================================================================================================================
 // Constructor / destructor / initialization / destroy
@@ -252,4 +256,20 @@
     calcAndPrintHashStatus(*rpcPic->getPicYuvRec(), hash);
   }
+#if Q0074_COLOUR_REMAPPING_SEI
+  if (m_colourRemapSEIEnabled)
+  {
+    SEIMessages colourRemappingInfo = getSeisByType(rpcPic->getSEIs(), SEI::COLOUR_REMAPPING_INFO );
+    const SEIColourRemappingInfo *seiColourRemappingInfo = ( colourRemappingInfo.size() > 0 ) ? (SEIColourRemappingInfo*) *(colourRemappingInfo.begin()) : NULL;
+    if (colourRemappingInfo.size() > 1)
+    {
+      printf ("Warning: Got multiple Colour Remapping Information SEI messages. Using first.");
+    }
+    applyColourRemapping(*rpcPic->getPicYuvRec(), seiColourRemappingInfo
+#if SVC_EXTENSION
+     , rpcPic->getLayerId()
+#endif
+     );
+  }
+#endif
 
 #if SETTING_PIC_OUTPUT_MARK
@@ -339,3 +359,168 @@
   }
 }
+
+#if Q0074_COLOUR_REMAPPING_SEI
+Void xInitColourRemappingLut( const Int bitDepthY, const Int bitDepthC, std::vector<Int>(&preLut)[3], std::vector<Int>(&postLut)[3], const SEIColourRemappingInfo* const pCriSEI )
+{
+  for ( Int c=0 ; c<3 ; c++ )
+  {  
+    Int bitDepth = c ? bitDepthC : bitDepthY ;
+    preLut[c].resize(1 << bitDepth);
+    postLut[c].resize(1 << pCriSEI->m_colourRemapTargetBitDepth);
+    
+    Int bitDepthDiff = pCriSEI->m_colourRemapTargetBitDepth - bitDepth;
+    Int iShift1 = (bitDepthDiff>0) ? bitDepthDiff : 0; //bit scale from bitdepth to TargetBitdepth (manage only case colourRemapTargetBitDepth>= bitdepth)
+    if( bitDepthDiff<0 )
+      printf ("Warning: CRI SEI - colourRemapTargetBitDepth (%d) <bitDepth (%d) - case not handled\n", pCriSEI->m_colourRemapTargetBitDepth, bitDepth);
+    bitDepthDiff = pCriSEI->m_colourRemapTargetBitDepth - pCriSEI->m_colourRemapCodedDataBitDepth;
+    Int iShift2 = (bitDepthDiff>0) ? bitDepthDiff : 0; //bit scale from codedDataBitdepth to TargetBitdepth (manage only case colourRemapTargetBitDepth>= colourRemapCodedDataBitDepth)
+    if( bitDepthDiff<0 )
+      printf ("Warning: CRI SEI - colourRemapTargetBitDepth (%d) <colourRemapCodedDataBitDepth (%d) - case not handled\n", pCriSEI->m_colourRemapTargetBitDepth, pCriSEI->m_colourRemapCodedDataBitDepth);
+
+    //Fill preLut
+    for ( Int k=0 ; k<(1<<bitDepth) ; k++ )
+    {
+      Int iSample = k << iShift1 ;
+      for ( Int iPivot=0 ; iPivot<=pCriSEI->m_preLutNumValMinus1[c] ; iPivot++ )
+      {
+        Int iCodedPrev  = pCriSEI->m_preLutCodedValue[c][iPivot]    << iShift2; //Coded in CodedDataBitdepth
+        Int iCodedNext  = pCriSEI->m_preLutCodedValue[c][iPivot+1]  << iShift2; //Coded in CodedDataBitdepth
+        Int iTargetPrev = pCriSEI->m_preLutTargetValue[c][iPivot];              //Coded in TargetBitdepth
+        Int iTargetNext = pCriSEI->m_preLutTargetValue[c][iPivot+1];            //Coded in TargetBitdepth
+        if ( iCodedPrev <= iSample && iSample <= iCodedNext )
+        {
+          Float fInterpol = (Float)( (iCodedNext - iSample)*iTargetPrev + (iSample - iCodedPrev)*iTargetNext ) * 1.f / (Float)(iCodedNext - iCodedPrev);
+          preLut[c][k]  = (Int)( 0.5f + fInterpol );
+          iPivot = pCriSEI->m_preLutNumValMinus1[c] + 1;
+        }
+      }
+    }
+    
+    //Fill postLut
+    for ( Int k=0 ; k<(1<<pCriSEI->m_colourRemapTargetBitDepth) ; k++ )
+    {
+      Int iSample = k;
+      for ( Int iPivot=0 ; iPivot<=pCriSEI->m_postLutNumValMinus1[c] ; iPivot++ )
+      {
+        Int iCodedPrev  = pCriSEI->m_postLutCodedValue[c][iPivot];    //Coded in TargetBitdepth
+        Int iCodedNext  = pCriSEI->m_postLutCodedValue[c][iPivot+1];  //Coded in TargetBitdepth
+        Int iTargetPrev = pCriSEI->m_postLutTargetValue[c][iPivot];   //Coded in TargetBitdepth
+        Int iTargetNext = pCriSEI->m_postLutTargetValue[c][iPivot+1]; //Coded in TargetBitdepth
+        if ( iCodedPrev <= iSample && iSample <= iCodedNext )
+        {
+          Float fInterpol =  (Float)( (iCodedNext - iSample)*iTargetPrev + (iSample - iCodedPrev)*iTargetNext ) * 1.f / (Float)(iCodedNext - iCodedPrev) ;
+          postLut[c][k]  = (Int)( 0.5f + fInterpol );
+          iPivot = pCriSEI->m_postLutNumValMinus1[c] + 1;
+        }
+      }
+    }
+  }
+}
+
+static void applyColourRemapping(TComPicYuv& pic, const SEIColourRemappingInfo* pCriSEI, UInt layerId )
+{  
+  if( !storeCriSEI.size() )
+#if SVC_EXTENSION
+    storeCriSEI.resize(MAX_LAYERS);
+#else
+    storeCriSEI.resize(1);
+#endif
+
+  if ( pCriSEI ) //if a CRI SEI has just been retrieved, keep it in memory (persistence management)
+    storeCriSEI[layerId] = *pCriSEI;
+
+  if( !storeCriSEI[layerId].m_colourRemapCancelFlag )
+  {
+    Int iHeight  = pic.getHeight();
+    Int iWidth   = pic.getWidth();
+    Int iStride  = pic.getStride();
+    Int iCStride = pic.getCStride();
+
+    Pel *YUVIn[3], *YUVOut[3];
+    YUVIn[0] = pic.getLumaAddr();
+    YUVIn[1] = pic.getCbAddr();
+    YUVIn[2] = pic.getCrAddr();
+    
+    TComPicYuv picColourRemapped;
+#if SVC_EXTENSION
+#if AUXILIARY_PICTURES
+    picColourRemapped.create( pic.getWidth(), pic.getHeight(), pic.getChromaFormat(), g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth, NULL );
+#else
+    picColourRemapped.create( pic.getWidth(), pic.getHeight(), g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth, NULL );
+#endif
+#else
+    picColourRemapped.create( pic.getWidth(), pic.getHeight(), g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth );
+#endif 
+    YUVOut[0] = picColourRemapped.getLumaAddr();
+    YUVOut[1] = picColourRemapped.getCbAddr();
+    YUVOut[2] = picColourRemapped.getCrAddr();
+
+#if SVC_EXTENSION
+    Int bitDepthY = g_bitDepthYLayer[layerId];
+    Int bitDepthC = g_bitDepthCLayer[layerId];
+
+    assert( g_bitDepthY == bitDepthY );
+    assert( g_bitDepthC == bitDepthC );
+#else
+    Int bitDepthY = g_bitDepthY;
+    Int bitDepthC = g_bitDepthC;
+#endif
+
+    std::vector<Int> preLut[3];
+    std::vector<Int> postLut[3];
+    xInitColourRemappingLut( bitDepthY, bitDepthC, preLut, postLut, &storeCriSEI[layerId] );
+    
+    Int roundingOffset = (storeCriSEI[layerId].m_log2MatrixDenom==0) ? 0 : (1 << (storeCriSEI[layerId].m_log2MatrixDenom - 1));
+
+    for( Int y = 0; y < iHeight ; y++ )
+    {
+      for( Int x = 0; x < iWidth ; x++ )
+      {
+        Int YUVPre[3], YUVMat[3];
+        YUVPre[0] = preLut[0][ YUVIn[0][x]   ];
+        YUVPre[1] = preLut[1][ YUVIn[1][x>>1] ];
+        YUVPre[2] = preLut[2][ YUVIn[2][x>>1] ];
+
+        YUVMat[0] = ( storeCriSEI[layerId].m_colourRemapCoeffs[0][0]*YUVPre[0]
+                    + storeCriSEI[layerId].m_colourRemapCoeffs[0][1]*YUVPre[1] 
+                    + storeCriSEI[layerId].m_colourRemapCoeffs[0][2]*YUVPre[2] 
+                    + roundingOffset ) >> ( storeCriSEI[layerId].m_log2MatrixDenom );
+        YUVMat[0] = Clip3( 0, (1<<storeCriSEI[layerId].m_colourRemapTargetBitDepth)-1, YUVMat[0] );
+        YUVOut[0][x] = postLut[0][ YUVMat[0] ];
+
+        if( (y&1) && (x&1) )
+        {
+          for(Int c=1 ; c<3 ; c++)
+          {
+            YUVMat[c] = ( storeCriSEI[layerId].m_colourRemapCoeffs[c][0]*YUVPre[0] 
+                        + storeCriSEI[layerId].m_colourRemapCoeffs[c][1]*YUVPre[1] 
+                        + storeCriSEI[layerId].m_colourRemapCoeffs[c][2]*YUVPre[2] 
+                        + roundingOffset ) >> ( storeCriSEI[layerId].m_log2MatrixDenom );
+            YUVMat[c] = Clip3( 0, (1<<storeCriSEI[layerId].m_colourRemapTargetBitDepth)-1, YUVMat[c] );
+            YUVOut[c][x>>1] = postLut[c][ YUVMat[c] ];   
+          }
+        }
+      }
+      YUVIn[0]  += iStride;
+      YUVOut[0] += iStride;
+      if( y&1 )
+      {
+        YUVIn[1]  += iCStride;
+        YUVIn[2]  += iCStride;
+        YUVOut[1] += iCStride;
+        YUVOut[2] += iCStride;
+      }
+    }
+
+    //Write remapped picture in decoding order
+    Char  cTemp[255];
+    sprintf(cTemp, "seiColourRemappedPic_L%d_%dx%d_%dbits.yuv", layerId, iWidth, iHeight, storeCriSEI[layerId].m_colourRemapTargetBitDepth );
+    picColourRemapped.dump( cTemp, true, storeCriSEI[layerId].m_colourRemapTargetBitDepth );
+
+    picColourRemapped.destroy();
+
+    storeCriSEI[layerId].m_colourRemapCancelFlag = !storeCriSEI[layerId].m_colourRemapPersistenceFlag; //Handling persistence
+  }
+}
+#endif
 //! \}
Index: branches/SHM-dev/source/Lib/TLibDecoder/TDecGop.h
===================================================================
--- branches/SHM-dev/source/Lib/TLibDecoder/TDecGop.h	(revision 855)
+++ branches/SHM-dev/source/Lib/TLibDecoder/TDecGop.h	(revision 856)
@@ -82,5 +82,7 @@
   Double                m_dDecTime;
   Int                   m_decodedPictureHashSEIEnabled;  ///< Checksum(3)/CRC(2)/MD5(1)/disable(0) acting on decoded picture hash SEI message
-
+#if Q0074_COLOUR_REMAPPING_SEI
+  Bool                  m_colourRemapSEIEnabled;         ///< Enable/disable Colour Remapping Information SEI message acting on decoded pictures
+#endif
 #if SVC_EXTENSION
   UInt                  m_layerId;
@@ -114,4 +116,7 @@
 
   void setDecodedPictureHashSEIEnabled(Int enabled) { m_decodedPictureHashSEIEnabled = enabled; }
+#if Q0074_COLOUR_REMAPPING_SEI
+  void setColourRemappingInfoSEIEnabled(Int enabled) { m_colourRemapSEIEnabled = enabled; }
+#endif
 #if SVC_EXTENSION
   TDecTop*   getLayerDec(UInt LayerId)  { return m_ppcTDecTop[LayerId]; }
Index: branches/SHM-dev/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- branches/SHM-dev/source/Lib/TLibDecoder/TDecTop.cpp	(revision 855)
+++ branches/SHM-dev/source/Lib/TLibDecoder/TDecTop.cpp	(revision 856)
@@ -117,8 +117,4 @@
 #endif
 
-#if Q0074_SEI_COLOR_MAPPING
-  m_ColorMapping = new TDecColorMapping();
-#endif
-
 #if POC_RESET_RESTRICTIONS
   resetPocRestrictionCheckParameters();
@@ -137,11 +133,4 @@
     delete m_pColorMappedPic;
     m_pColorMappedPic = NULL;
-  }
-#endif
-#if Q0074_SEI_COLOR_MAPPING
-  if ( m_ColorMapping )
-  {
-    delete m_ColorMapping;
-    m_ColorMapping = NULL;
   }
 #endif
@@ -891,11 +880,4 @@
   g_uiMaxCUDepth  = sps->getMaxCUDepth();
   g_uiAddCUDepth  = max (0, sps->getLog2MinCodingBlockSize() - (Int)sps->getQuadtreeTULog2MinSize() );
-
-#if Q0074_SEI_COLOR_MAPPING
-  for(Int compID=0; compID<3; compID++)
-  {
-    m_ColorMapping->setColorMapping( compID ? g_bitDepthC : g_bitDepthY, compID );
-  }
-#endif
 
   for (Int i = 0; i < sps->getLog2DiffMaxMinCodingBlockSize(); i++)
@@ -2324,7 +2306,4 @@
       }
     }
-#if Q0074_SEI_COLOR_MAPPING
-    m_ColorMapping->setColorMapping( m_SEIs );
-#endif
   }
 #else
@@ -2857,305 +2836,4 @@
 #endif //SVC_EXTENSION
 
-#if Q0074_SEI_COLOR_MAPPING
-TDecColorMapping::TDecColorMapping()
-{
-  m_pcColorMappingPic[0]   = NULL;
-  m_pcColorMappingPic[1]   = NULL;
-
-  m_colorMapCancelFlag  = true;
-
-  for( Int i=0 ; i<3 ; i++ )
-  {
-    m_lut1d_computed[i]             = false;
-    m_lut1d_input[i]                = NULL;
-    m_coded_input_pivot_value[i]    = NULL;
-    m_target_input_pivot_value[i]   = NULL;
-  }
-  for( Int i=0 ; i<3 ; i++ )
-  {
-    m_lut1d_output[i]               = NULL;
-    m_coded_output_pivot_value[i]   = NULL;
-    m_target_output_pivot_value[i]  = NULL;
-  }
-}
-
-TDecColorMapping::~TDecColorMapping()
-{
-  if ( m_pcColorMappingPic[0] )  delete m_pcColorMappingPic[0];
-  if ( m_pcColorMappingPic[1] )  delete m_pcColorMappingPic[1];
-
-  for( Int i=0 ; i<3 ; i++ )
-  {
-    if ( m_lut1d_input[i] )               delete  m_lut1d_input[i];
-    if ( m_coded_input_pivot_value[i] )   delete  m_coded_input_pivot_value[i];
-    if ( m_target_input_pivot_value[i] )  delete  m_target_input_pivot_value[i];
-  }
-  for( Int i=0 ; i<3 ; i++ )
-  {
-    if ( m_lut1d_output[i] )               delete  m_lut1d_output[i];
-    if ( m_coded_output_pivot_value[i] )   delete  m_coded_output_pivot_value[i];
-    if ( m_target_output_pivot_value[i] )  delete  m_target_output_pivot_value[i];
-  }
-}
-
-Void  TDecColorMapping::setColorMapping( SEIMessages m_SEIs )
-{
-  SEIMessages colorMappingInfo = getSeisByType(m_SEIs, SEI::COLOR_MAPPING_INFO) ;
-  SEIColorMappingInfo *seiColorMappingInfo = NULL;
-  if (colorMappingInfo.size() !=0)
-  {
-    seiColorMappingInfo = (SEIColorMappingInfo*)(*colorMappingInfo.begin());
-
-    m_colorMapId                              = seiColorMappingInfo->m_colorMapId;
-    m_colorMapCancelFlag                      = seiColorMappingInfo->m_colorMapCancelFlag;
-    if( !m_colorMapCancelFlag )
-    {
-      m_colorMapPersistenceFlag                 = seiColorMappingInfo->m_colorMapPersistenceFlag;
-      m_colorMap_video_signal_type_present_flag = seiColorMappingInfo->m_colorMap_video_signal_type_present_flag;
-      m_colorMap_video_full_range_flag          = seiColorMappingInfo->m_colorMap_video_full_range_flag;
-      m_colorMap_primaries                      = seiColorMappingInfo->m_colorMap_primaries;
-      m_colorMap_transfer_characteristics       = seiColorMappingInfo->m_colorMap_transfer_characteristics;
-      m_colorMap_matrix_coeffs                  = seiColorMappingInfo->m_colorMap_matrix_coeffs;
-      m_colorMapModelId                         = seiColorMappingInfo->m_colorMapModelId;
-
-      m_colour_map_coded_data_bit_depth         = seiColorMappingInfo->m_colour_map_coded_data_bit_depth;
-      m_colour_map_target_bit_depth             = seiColorMappingInfo->m_colour_map_target_bit_depth;
-
-      for( Int i=0 ; i<3 ; i++ )
-      {
-        m_num_input_pivots[i]                 = seiColorMappingInfo->m_num_input_pivots[i];
-        if ( m_coded_input_pivot_value[i] )   delete  m_coded_input_pivot_value[i];
-        if ( m_target_input_pivot_value[i] )  delete  m_target_input_pivot_value[i];
-        m_coded_input_pivot_value[i]          = new Int[ m_num_input_pivots[i] ];
-        m_target_input_pivot_value[i]         = new Int[ m_num_input_pivots[i] ];
-        for( Int j=0 ; j<m_num_input_pivots[i] ; j++ )
-        {
-          m_coded_input_pivot_value[i][j]     = seiColorMappingInfo->m_coded_input_pivot_value[i][j];
-          m_target_input_pivot_value[i][j]    = seiColorMappingInfo->m_target_input_pivot_value[i][j];
-        }
-      }
-
-      m_matrix_flag       = seiColorMappingInfo->m_matrix_flag;
-      m_log2_matrix_denom = m_matrix_flag ? (seiColorMappingInfo->m_log2_matrix_denom) : (0) ;
-      for( Int i=0 ; i<3 ; i++ )
-      {
-        for( Int j=0 ; j<3 ; j++ )
-        {
-          m_matrix_coef[i][j]  = seiColorMappingInfo->m_matrix_coef[i][j];
-        }
-      }
-
-      for( Int i=0 ; i<3 ; i++ )
-      {
-        m_num_output_pivots[i]                 = seiColorMappingInfo->m_num_output_pivots[i];
-        if ( m_coded_output_pivot_value[i] )   delete  m_coded_output_pivot_value[i];
-        if ( m_target_output_pivot_value[i] )  delete  m_target_output_pivot_value[i];
-        m_coded_output_pivot_value[i]          = new Int[ m_num_output_pivots[i] ];
-        m_target_output_pivot_value[i]         = new Int[ m_num_output_pivots[i] ];
-        for( Int j=0 ; j<m_num_output_pivots[i] ; j++ )
-        {
-          m_coded_output_pivot_value[i][j]     = seiColorMappingInfo->m_coded_output_pivot_value[i][j];
-          m_target_output_pivot_value[i][j]    = seiColorMappingInfo->m_target_output_pivot_value[i][j];
-        }
-      }
-
-      memset( m_lut1d_computed, 0, sizeof( m_lut1d_computed ) );
-    }
-  }
-
-}
-
-Void  TDecColorMapping::setColorMapping( Int bitDepth, Int iComp )
-{
-  if( !m_colorMapCancelFlag && !m_lut1d_computed[iComp] )
-  {
-
-    if ( m_lut1d_input[iComp] )   delete m_lut1d_input[iComp];
-    if ( m_lut1d_output[iComp] )  delete m_lut1d_output[iComp];
-
-    m_lut1d_input[iComp]  = new Int[ 1 << bitDepth ];
-    m_lut1d_output[iComp] = new Int[ 1 << bitDepth ];
-
-    Int iShift      = (m_colour_map_coded_data_bit_depth >= bitDepth) ? (m_colour_map_coded_data_bit_depth - bitDepth) : (0);
-    Int iShiftPivot = (m_colour_map_coded_data_bit_depth >= bitDepth) ? (0) : (bitDepth - m_colour_map_coded_data_bit_depth);
-
-    for( Int k=0 ; k<(1<<bitDepth) ; k++ )
-    {
-      Int iSample = k << iShift ;
-      if( m_num_input_pivots[iComp] > 1 )
-      {
-        for( Int iPivot=0 ; iPivot<m_num_input_pivots[iComp] ; iPivot++ )
-        {
-          Int iCodedPrev  = m_coded_input_pivot_value[iComp][iPivot]     << iShiftPivot;
-          Int iCodedNext  = m_coded_input_pivot_value[iComp][iPivot+1]   << iShiftPivot;
-          Int iTargetPrev = m_target_input_pivot_value[iComp][iPivot]    << iShiftPivot;
-          Int iTargetNext = m_target_input_pivot_value[iComp][iPivot+1]  << iShiftPivot;
-          if ( iCodedPrev <= iSample && iSample < iCodedNext )
-          {
-            Float fInterpol = (Float)( (iCodedNext - iSample)*iTargetPrev + (iSample - iCodedPrev)*iTargetNext ) / (Float)(iCodedNext - iCodedPrev) ;
-            m_lut1d_input[iComp][k]  = (Int)( 0.5 + fInterpol );
-            iPivot = m_num_input_pivots[iComp]; // stop
-          }
-        }
-      }
-      else
-      {
-        m_lut1d_input[iComp][k]  = k;
-      }
-    }
-
-    iShift      = ( (m_colour_map_coded_data_bit_depth >= bitDepth) ? (m_colour_map_coded_data_bit_depth - bitDepth) : (0) );
-    Int iOffset = iShift ? (1 << (iShift - 1)) : (0) ;
-    iShiftPivot = (m_colour_map_target_bit_depth >= bitDepth) ? (0) : (bitDepth - m_colour_map_target_bit_depth) ;
-    for( Int k=0 ; k<(1<<bitDepth) ; k++ )
-    {
-      Int iSample = k << iShift;
-      if ( m_num_output_pivots[iComp]>1 )
-      {
-        for( Int iPivot=0 ; iPivot<m_num_output_pivots[iComp] ; iPivot++ )
-        {
-          Int iCodedPrev  = m_coded_output_pivot_value[iComp][iPivot]     << iShiftPivot;
-          Int iCodedNext  = m_coded_output_pivot_value[iComp][iPivot+1]   << iShiftPivot;
-          Int iTargetPrev = m_target_output_pivot_value[iComp][iPivot]    << iShiftPivot;
-          Int iTargetNext = m_target_output_pivot_value[iComp][iPivot+1]  << iShiftPivot;
-          if ( iCodedPrev <= iSample && iSample < iCodedNext )
-          {
-            Float fInterpol =  (Float)( (iCodedNext - iSample)*iTargetPrev + (iSample - iCodedPrev)*iTargetNext ) / (Float)(iCodedNext - iCodedPrev) ;
-            m_lut1d_output[iComp][k]  = ( (Int)(0.5 + fInterpol) + iOffset ) >> iShift ;
-            iPivot = m_num_output_pivots[iComp]; // stop
-          }
-        }
-      }
-      else
-      {
-        m_lut1d_output[iComp][k]  = k;
-      }
-    }
-
-    m_lut1d_computed[iComp] = true;
-  }
-
-}
-
-TComPicYuv* TDecColorMapping::getColorMapping( TComPicYuv* pPicYuvRec, Int iTop, Int curlayerId )
-{
-  if( !m_colorMapCancelFlag )
-  {
-    if( !m_pcColorMappingPic[iTop] )
-    {
-      m_pcColorMappingPic[iTop] = new TComPicYuv;
-#if SVC_EXTENSION
-      m_pcColorMappingPic[iTop]->create( pPicYuvRec->getWidth(), pPicYuvRec->getHeight(), pPicYuvRec->getChromaFormat(), g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth );
-#else
-      m_pcColorMappingPic[iTop]->create( pPicYuvRec->getWidth(), pPicYuvRec->getHeight(), g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth );
-#endif
-    }
-
-    Int iHeight   = pPicYuvRec->getHeight();
-    Int iWidth    = pPicYuvRec->getWidth();
-    Int iStride   = pPicYuvRec->getStride();
-    Int iCStride  = pPicYuvRec->getCStride();
-
-    Pel* Lum0   = pPicYuvRec->getLumaAddr();
-    Pel* Cb0    = pPicYuvRec->getCbAddr();
-    Pel* Cr0    = pPicYuvRec->getCrAddr();
-    Pel* Lum1   = m_pcColorMappingPic[iTop]->getLumaAddr();
-    Pel* Cb1    = m_pcColorMappingPic[iTop]->getCbAddr();
-    Pel* Cr1    = m_pcColorMappingPic[iTop]->getCrAddr();
-
-#if SVC_EXTENSION
-    Int bitDepthY = g_bitDepthYLayer[curlayerId];
-    Int bitDepthC = g_bitDepthCLayer[curlayerId];
-
-    assert( g_bitDepthY == bitDepthY );
-    assert( g_bitDepthC == bitDepthC );
-#else
-    Int bitDepthY = g_bitDepthY;
-    Int bitDepthC = g_bitDepthC;
-#endif
-
-    Int iYShift = (m_colour_map_target_bit_depth >= bitDepthY) ? (m_colour_map_target_bit_depth - bitDepthY) : (0) ;
-    Int iCShift = (m_colour_map_target_bit_depth >= bitDepthC) ? (m_colour_map_target_bit_depth - bitDepthC) : (0) ;
-    Int offsetY = (1 << (m_log2_matrix_denom+iYShift - 1));
-    Int offsetC = (1 << (m_log2_matrix_denom+iCShift - 1));
-
-    Int   cShift  = 1 ;
-
-    //Pel*  LumPrev0 = Lum0;
-    for( Int y = 0; y < iHeight ; y++ )
-    {
-      Bool  bDoChroma = (y % 2);
-      for( Int x = 0; x < iWidth ; x++ )
-      {
-        Int s1Y = m_lut1d_input[0][ Lum0[x]   ];
-        Int s1U = m_lut1d_input[1][ Cb0[x>>1] ];
-        Int s1V = m_lut1d_input[2][ Cr0[x>>1] ];
-
-        Int s2Y, s2U, s2V;
-        if( m_matrix_flag )
-        {
-          s2Y = ( m_matrix_coef[0][0]*s1Y + m_matrix_coef[0][1]*s1U + m_matrix_coef[0][2]*s1V + offsetY ) >> ( m_log2_matrix_denom + iYShift );
-          //s2Y = ClipBD( s2Y , bitDepthY );
-          s2Y = ClipY( s2Y );
-          Lum1[x]   = m_lut1d_output[0][ s2Y ];
-        }
-        else
-        {
-          s1Y       = ( s1Y + offsetY ) >> iYShift ;
-          //s1Y = ClipBD( s1Y , bitDepthY );
-          s1Y = ClipY( s1Y );
-          Lum1[x]   = m_lut1d_output[0][ s1Y ];
-        }
-
-        if( bDoChroma && (x%2) )
-        {
-          if( m_matrix_flag )
-          {
-            //s1Y = ( m_lut1d_input[0][ Lum0[x] ] + m_lut1d_input[0][ Lum0[x+1] ] + m_lut1d_input[0][ LumPrev0[x] ] + m_lut1d_input[0][ LumPrev0[x+1] ] + 2 ) >> 2 ; 
-            //s1Y = m_lut1d_input[0][ (Lum0[x] + Lum0[x+1] + LumPrev0[x] + LumPrev0[x+1] + 2)>>2 ] ; 
-            s1Y = m_lut1d_input[0][ Lum0[x] ];
-
-            s2U = ( m_matrix_coef[1][0]*s1Y + m_matrix_coef[1][1]*s1U + m_matrix_coef[1][2]*s1V + offsetC ) >> ( m_log2_matrix_denom + iCShift ) ;
-            s2V = ( m_matrix_coef[2][0]*s1Y + m_matrix_coef[2][1]*s1U + m_matrix_coef[2][2]*s1V + offsetC ) >> ( m_log2_matrix_denom + iCShift ) ;
-            //s2U = ClipBD( s2U , bitDepthC );
-            //s2V = ClipBD( s2V , bitDepthC );
-            s2U = ClipC( s2U );
-            s2V = ClipC( s2V );
-            Cb1[x>>cShift] = m_lut1d_output[1][ s2U ];
-            Cr1[x>>cShift] = m_lut1d_output[2][ s2V ];
-          }
-          else
-          {
-            s1U       = ( s1U + offsetC ) >> iCShift ;
-            s1V       = ( s1V + offsetC ) >> iCShift ;
-            //s1U = ClipBD( s1U , bitDepthC );
-            //s1V = ClipBD( s1V , bitDepthC );
-            s1U = ClipC( s1U );
-            s1V = ClipC( s1V );
-            Cb1[x>>cShift] = m_lut1d_output[1][ s1U ];
-            Cr1[x>>cShift] = m_lut1d_output[2][ s1V ];
-          }
-        }
-
-      }
-
-      //LumPrev0 = Lum0;
-      Lum0  += iStride;
-      Lum1  += iStride;
-      if( bDoChroma )
-      {
-        Cb0 += iCStride;
-        Cr0 += iCStride;
-        Cb1 += iCStride;
-        Cr1 += iCStride;
-      }
-    }
-
-    return m_pcColorMappingPic[iTop];
-  }
-
-  return pPicYuvRec; 
-}
-#endif
 
 //! \}
Index: branches/SHM-dev/source/Lib/TLibDecoder/TDecTop.h
===================================================================
--- branches/SHM-dev/source/Lib/TLibDecoder/TDecTop.h	(revision 855)
+++ branches/SHM-dev/source/Lib/TLibDecoder/TDecTop.h	(revision 856)
@@ -64,49 +64,4 @@
 // ====================================================================================================================
 
-#if Q0074_SEI_COLOR_MAPPING
-class TDecColorMapping
-{
-  Int   m_colorMapId;
-  Bool  m_colorMapCancelFlag;
-  Bool  m_colorMapPersistenceFlag;
-  Bool  m_colorMap_video_signal_type_present_flag;
-  Bool  m_colorMap_video_full_range_flag;
-  Int   m_colorMap_primaries;
-  Int   m_colorMap_transfer_characteristics;
-  Int   m_colorMap_matrix_coeffs;
-  Int   m_colorMapModelId;
-
-  Int   m_colour_map_coded_data_bit_depth;
-  Int   m_colour_map_target_bit_depth;
-
-  Int   m_num_input_pivots[3];
-  Int*  m_coded_input_pivot_value[3];
-  Int*  m_target_input_pivot_value[3];
-  
-  Bool  m_matrix_flag;
-  Int   m_log2_matrix_denom;
-  Int   m_matrix_coef[3][3];
-
-  Int   m_num_output_pivots[3];
-  Int*  m_coded_output_pivot_value[3];
-  Int*  m_target_output_pivot_value[3];
-
-  Bool  m_lut1d_computed[3];
-  Int*  m_lut1d_input[3];
-  Int*  m_lut1d_output[3];
-  TComPicYuv* m_pcColorMappingPic[2];
-
-public:
-  TDecColorMapping();
-  ~TDecColorMapping();
-
-  Bool        getColorMappingFlag()                     { return(!m_colorMapCancelFlag);};
-
-  Void        setColorMapping( SEIMessages m_SEIs );
-  Void        setColorMapping( Int bitDepthY, Int bitDepthC );
-  TComPicYuv* getColorMapping( TComPicYuv* pPicYuvRec, Int iTop=0, Int curlayerId=0 );
-};// END CLASS DEFINITION TDecColorMapping
-#endif
-
 /// decoder class
 class TDecTop
@@ -209,8 +164,4 @@
 #endif
 public:
-#if Q0074_SEI_COLOR_MAPPING
-  TDecColorMapping* m_ColorMapping;
-#endif
-
 #if POC_RESET_RESTRICTIONS
   static Bool                    m_checkPocRestrictionsForCurrAu;
@@ -236,4 +187,7 @@
 
   void setDecodedPictureHashSEIEnabled(Int enabled) { m_cGopDecoder.setDecodedPictureHashSEIEnabled(enabled); }
+#if Q0074_COLOUR_REMAPPING_SEI
+  void setColourRemappingInfoSEIEnabled(Bool enabled)  { m_cGopDecoder.setColourRemappingInfoSEIEnabled(enabled); }
+#endif
 
   Void  init();
